package xamora.gp_dbc.gui.CriminalTracker;

import xamora.gp_dbc.Main;
import xamora.gp_dbc.network.server.NetworkRefreshCriminalTracker;
import xamora.gp_dbc.proxy.CommonProxy;
import xamora.gp_dbc.system.Criminal;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import java.util.List;

public class GuiCriminalTracker extends GuiScreen {

    final static int guiWidth = 308 / 2 + 1;
    final static int guiHeight = 360 / 2 + 1;

    public static int scroll_y = 0;

    public static int wdth;
    public static int hght;

    public static long MAX_RATE_CRIMINAL;
    public static long RATE_TO_HAVE_POSITION;
    public static long RATE_CRIMINAL_NOT_SAFE;

    public static List<Criminal> criminals;
    int gap_y = 2;
    int number_by_line = 3;
    int nbr_visible = 6;
    int criminal_width = 84 / 2;
    int criminal_height = 104 / 2;

    private GuiButtonCriminalTracker refresh_criminal;

    public GuiCriminalTracker(List<Criminal> criminals, long[] config) {
        GuiCriminalTracker.criminals = criminals;
        scroll_y = 0;
        MAX_RATE_CRIMINAL = config[0];
        RATE_TO_HAVE_POSITION = config[1];
        RATE_CRIMINAL_NOT_SAFE = config[2];
    }

    @Override
    public void drawScreen(int mouse_x, int mouse_y, float ticks) {

        GL11.glColor4f(1, 1, 1, 1);

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        drawDefaultBackground();

        mc.renderEngine.bindTexture(new ResourceLocation(Main.MODID, "textures/gui/criminalTracker.png"));

        // Texture
        GL11.glPushMatrix();
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        drawTexturedModalRect(guiX, guiY, 0, 0, guiWidth, guiHeight);
        GL11.glPopMatrix();


        int scrollbar_x = guiX + 141;
        int scrollbar_y = guiY + 70 / 2;
        int scrollbar_add = 0;

        if (criminals.size() > nbr_visible) {

            GL11.glPushMatrix();
            GL11.glEnable(GL11.GL_BLEND);
            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
            GL11.glTranslated(0,0, 1);

            scrollbar_add = (int)(108D / getMaxScrollY() * scroll_y); // doit varier entre 0 et 108
            scrollbar_add = Math.max(scrollbar_add, 0);

            //-((criminals.size() - 6) * (criminal_height + gap_y))
            //drawRect(scrollbar_x, scrollbar_y, scrollbar_x + 6, scrollbar_y + 6, 0xff000000);

            GL11.glPopMatrix();
        }

        GL11.glPushMatrix();
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        drawTexturedModalRect(scrollbar_x, scrollbar_y, 312 / 2, 108 / 2, 24 / 2, 268 / 2); // Background
        if (criminals.size() > nbr_visible)
            drawTexturedModalRect(scrollbar_x - 2, scrollbar_y + scrollbar_add, 338 / 2, 108 / 2, 32 / 2, 52 / 2); // Point
        GL11.glPopMatrix();



        super.drawScreen(mouse_x, mouse_y, ticks);
    }

    public int getMaxScrollY() {
        int size = criminals.size();
        int visible_criminal_line = (int) Math.ceil((size - nbr_visible) / (double)number_by_line);
        int scroll_y_max = visible_criminal_line * (criminal_height + gap_y) - criminal_height / 2;
        return -scroll_y_max;
    }

    @Override
    public void initGui() {

        if (criminals == null) {
            Minecraft.getMinecraft().displayGuiScreen(null);
            Minecraft.getMinecraft().thePlayer.addChatComponentMessage(new ChatComponentText(EnumChatFormatting.RED + "Error null criminals"));
            return;
        }

        wdth = width;
        hght = height;

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        buttonList.clear();

        for (int i = 0 ; i < criminals.size(); i++) {
            int pos_x = guiX + 8 + (i % number_by_line) * (criminal_width + 2);
            int pos_y = guiY + 70 / 2 + (i / number_by_line) * (criminal_height + gap_y);
            buttonList.add(new GuiButtonCriminalTracker(-(i + 1), pos_x, pos_y, criminal_width + 1, criminal_height + 1));
        }

        buttonList.add(refresh_criminal = new GuiButtonCriminalTracker(0, guiX + 15, guiY + 10, 32 / 2 + 1, 32 / 2 + 1));

        //buttonList.add(buttonClose = new CyborgSoftwareGuiButton(1, guiX + 4, guiY - 3, 7, 7));


        super.initGui();
    }

    @Override
    protected void actionPerformed(GuiButton button) {
        if (button.id == 0)
            CommonProxy.network.sendToServer(new NetworkRefreshCriminalTracker(""));
        super.actionPerformed(button);
    }

    @Override
    protected void mouseClicked(int x, int y, int btn) {
        super.mouseClicked(x, y, btn);
    }

    @Override
    public void handleMouseInput() {
        super.handleMouseInput();

        if (criminals.size() <= nbr_visible)
            return;

        int dWheel = Mouse.getEventDWheel();

        //System.out.println(dWheel);
        if (dWheel != 0) {
            if (dWheel > 0) {
                scroll_y += 6;
                scroll_y = Math.min(0, scroll_y);
                //System.out.println("Molette vers le haut");
            } else {
                scroll_y -= 6;
                scroll_y = Math.max(getMaxScrollY(), scroll_y);
                //System.out.println("Molette vers le bas");
            }
        }
    }

    @Override
    public void updateScreen() {
        super.updateScreen();
    }
}