package xamora.gp_dbc.gui;

import JinRyuu.JRMCore.JRMCoreH;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.system.Handcuffed;
import xamora.gp_dbc.utils.TextUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import org.lwjgl.opengl.GL11;

import static xamora.gp_dbc.utils.DrawGui.*;
import static net.minecraft.util.StatCollector.translateToLocal;

public class GuiHandcuffed extends Gui {

    private Minecraft mc = Minecraft.getMinecraft();

    private final ResourceLocation gui_handcuffed = new ResourceLocation(Main.MODID + ":textures/gui/handcuffed.png");

    int guiWidth = 70 / 2 + 1;
    int guiHeight = 35 / 2 + 1;

    public static long startTime = System.currentTimeMillis();

    // Client Side
    public static boolean handcuffed = false;

    @SubscribeEvent
    public void RenderHandcuffTime(RenderGameOverlayEvent event)
    {

        // Pour éviter d'impacter d'autre gui
        if(event.type == RenderGameOverlayEvent.ElementType.EXPERIENCE || event.type == RenderGameOverlayEvent.ElementType.FOOD
                || event.type == RenderGameOverlayEvent.ElementType.HEALTHMOUNT || event.type == RenderGameOverlayEvent.ElementType.HEALTH
                || event.type == RenderGameOverlayEvent.ElementType.CHAT || event.type == RenderGameOverlayEvent.ElementType.BOSSHEALTH
                || event.type == RenderGameOverlayEvent.ElementType.PLAYER_LIST || event.type == RenderGameOverlayEvent.ElementType.HELMET
                || event.type == RenderGameOverlayEvent.ElementType.JUMPBAR || event.type == RenderGameOverlayEvent.ElementType.AIR
                || event.type == RenderGameOverlayEvent.ElementType.CROSSHAIRS || event.type == RenderGameOverlayEvent.ElementType.DEBUG || event.type == RenderGameOverlayEvent.ElementType.ARMOR
                || event.type == RenderGameOverlayEvent.ElementType.PORTAL || event.type == RenderGameOverlayEvent.ElementType.TEXT
                || event.type == RenderGameOverlayEvent.ElementType.HOTBAR)
            return;

        long time_left = (startTime + (Handcuffed.timeToWait * 1000) - System.currentTimeMillis()) / 1000;

        if (event.isCancelable())
            return;
        //if (time_left < -timeToWait)
            //return;

        if (JRMCoreH.ko <= 0)
            return;
        if (!handcuffed)
            return;

        int width = (int) (event.resolution.getScaledWidth());
        int height = (int) (event.resolution.getScaledHeight());

        GL11.glPushMatrix();
        GL11.glDepthMask(false);
        mc.renderEngine.bindTexture(gui_handcuffed);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        drawTexturedModalRect(width / 2 - guiWidth / 2 - 20, 20 - guiHeight / 2, 0, 0, guiWidth, guiHeight + 1);
        GL11.glDepthMask(true);
        GL11.glPopMatrix();

        String[] texts = TextUtils.getSeparateText(translateToLocal("warning.going_in_jail"), "%%");
        if (texts != null)
            drawLimitedShadow(mc.fontRenderer, texts[0] + time_left + texts[1], width / 2, 17, 70  , 9, 0xffffff);
    }
}
