package xamora.gp_dbc.gui.JailManager;

import xamora.gp_dbc.Main;
import xamora.gp_dbc.system.Cell;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;

import static net.minecraft.util.StatCollector.translateToLocal;
import static xamora.gp_dbc.gui.JailManager.GuiJailManager.*;
import static xamora.gp_dbc.utils.DrawGui.drawLimited;

public class GuiButtonJailManager extends GuiButton {

    private static final ResourceLocation buttonTexturesNinjin = new ResourceLocation(Main.MODID, "textures/gui/jailManager.png");
    ItemStack stack;

    public GuiButtonJailManager(int buttonId, int x, int y, int width, int height)
    {
        super(buttonId, x, y, "");
        this.enabled = true;
        this.visible = true;
        this.id = buttonId;
        this.xPosition = x;
        this.yPosition = y;
        this.origin_yPosition = y;
        this.width = width;
        this.height = height;
    }
    
    private int last_scroll_y;
    private int origin_yPosition;

    /**
     * Draws this button to the screen.
     **/
    @Override
    public void drawButton(Minecraft mc, int x, int y) {
        if (!this.visible)
            return;

        mc.getTextureManager().bindTexture(buttonTexturesNinjin);

        boolean flag = x >= xPosition && y >= yPosition && x < xPosition + this.width && y < yPosition + this.height;
        if (id < 0) { // cells

            if (last_scroll_y != scroll_y) {
                last_scroll_y = scroll_y;
                yPosition = origin_yPosition + scroll_y;
            }

            int displayWidth = mc.displayWidth;
            int displayHeight = mc.displayHeight;

            int ratioWidth = (int) Math.round((double) displayWidth / wdth);
            int ratioHeight = (int) Math.round((double) displayHeight / hght);

            int newWidth = guiWidth * ratioWidth;
            int newHeight = guiHeight * ratioHeight;

            int displayGuiX = (int) Math.round((double) (displayWidth - newWidth) / 2);
            int displayGuiY = (int) Math.round((double) (displayHeight - newHeight) / 2);

            Cell cell = cells.get(-(id) - 1);


            GL11.glPushMatrix();
            GL11.glScissor(displayGuiX, displayGuiY + 54 * ratioHeight, newWidth, (int) (newHeight - 91 * ratioHeight));
            GL11.glEnable(GL11.GL_SCISSOR_TEST);

            if (flag || cell_selected == cell.getId()) {
                drawRect(xPosition, yPosition, xPosition + width, yPosition + height, 0xffd6d6d6);

            } else {
                drawRect(xPosition, yPosition, xPosition + width, yPosition + height, 0xffffffff);
            }
            drawLimited(mc.fontRenderer, translateToLocal("gui.jail.cell") + "#" + cell.getId() + " " + cell.getInmates().size() + "/" + cell.getPlace(), xPosition, yPosition + 1, width - 1, height, 0xff000000);

            GL11.glDisable(GL11.GL_SCISSOR_TEST);
            GL11.glPopMatrix();

            if (flag) {
                GL11.glPushMatrix();
                GL11.glTranslated(0, 0, 1);

                String text = "x: " + cell.getPos().x + " y :" + cell.getPos().y + " z: " + cell.getPos().z + " dim: " + cell.getPos().dimension;
                int width = (int) (mc.fontRenderer.getStringWidth(text) * 0.8 - 1);
                int height = 10;

                drawRect(x, y, x + width, y - height, 0xf0ffffff);
                drawLimited(mc.fontRenderer, text, x + 1, y - height + 1, width - 2, height - 1, 0x00000000);
                GL11.glPopMatrix();

            }
        }
        else if (id == 0) { // edit
            GL11.glPushMatrix();

            GL11.glColor4d(.4, .4, .4, 1);

            if (flag && cell_selected != -1)
                GL11.glColor4d(1, 1, 1, 1);
            else
                if (cell_selected != -1)
                    GL11.glColor4d(.8, .8, .8, 1);
            this.drawTexturedModalRect(this.xPosition, this.yPosition, 108, 0, this.width, this.height);
            this.drawTexturedModalRect(this.xPosition + this.width / 2 - 18 / 2 + 1, this.yPosition + this.height / 2 - 17 /2, 144, 0, 18, 17);

            GL11.glPopMatrix();
        }
        else if (id == 1) { // Delete
            GL11.glPushMatrix();

            GL11.glColor4d(.4, .4, .4, 1);

            if (flag && cell_selected != -1)
                GL11.glColor4d(1, 1, 1, 1);
            else
            if (cell_selected != -1)
                GL11.glColor4d(.8, .8, .8, 1);
            this.drawTexturedModalRect(this.xPosition, this.yPosition, 108, 0, this.width, this.height);
            this.drawTexturedModalRect(this.xPosition + this.width / 2 - 14 / 2 + 1, this.yPosition + this.height / 2 - 15 / 2, 130, 0, 14, 15);

            GL11.glPopMatrix();
        }
    }
}
