package xamora.gp_dbc.network.client;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import xamora.gp_dbc.config.ConfigManager;
import xamora.gp_dbc.gui.CriminalTracker.GuiCriminalTracker;
import xamora.gp_dbc.system.Criminal;
import xamora.gp_dbc.utils.Pos;
import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class NetworkCriminalTrackerC implements IMessage {

    private String toSend;

    public NetworkCriminalTrackerC() {
    }

    public NetworkCriminalTrackerC(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf, toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandlerC implements
            IMessageHandler<NetworkCriminalTrackerC, IMessage> {

        @SideOnly(Side.CLIENT)
        @Override
        public IMessage onMessage(NetworkCriminalTrackerC message,
                                  MessageContext ctx) {

            String[] split = message.toSend.split("~");
            String key = split[0];

            if (key.equals("open")) {

                List<Criminal> criminals = new ArrayList<>();

                if (split.length > 1) {
                    String content = split[1];

                    try {
                        String[] criminals_string = content.split("#");
                        for (String criminal_string : criminals_string) {
                            String[] info_criminal = criminal_string.split("\\$");
                            UUID uuid = UUID.fromString(info_criminal[0]);
                            String name = info_criminal[1];
                            long rate = Long.parseLong(info_criminal[2]);
                            long last_time_pos = Long.parseLong(info_criminal[3]);

                            Pos pos = null;
                            if (info_criminal.length > 4) {
                                String[] split_pos = info_criminal[4].split("@");
                                pos = new Pos(Integer.parseInt(split_pos[0]), Integer.parseInt(split_pos[1]), Integer.parseInt(split_pos[2]), Integer.parseInt(split_pos[3]), split_pos[4]);
                            }

                            criminals.add(new Criminal(uuid, name, rate, last_time_pos, pos));
                        }
                    } catch (Exception e) {
                        System.out.println(e);
                    }
                }

                String[] config = split[2].split("#");
                long MAX_RATE_CRIMINAL = ConfigManager.MAX_RATE_CRIMINAL;
                long RATE_TO_HAVE_POSITION = ConfigManager.RATE_TO_HAVE_POSITION;
                long RATE_CRIMINAL_NOT_SAFE = ConfigManager.RATE_CRIMINAL_NOT_SAFE;
                try {
                    MAX_RATE_CRIMINAL = Long.parseLong(config[0]);
                    RATE_TO_HAVE_POSITION = Long.parseLong(config[1]);
                    RATE_CRIMINAL_NOT_SAFE = Long.parseLong(config[2]);
                } catch (Exception e) {
                    System.out.println(e);
                }

                Minecraft.getMinecraft().displayGuiScreen(new GuiCriminalTracker(criminals, new long[]{MAX_RATE_CRIMINAL, RATE_TO_HAVE_POSITION, RATE_CRIMINAL_NOT_SAFE}));
            }

            return null;
        }
    }
}