package xamora.gp_dbc.network.server;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import xamora.gp_dbc.utils.InputUtils;
import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayerMP;

public class NetworkKeyManage implements IMessage {

    private String toSend;

    public NetworkKeyManage() {}

    public NetworkKeyManage(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf,toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandler implements
            IMessageHandler<NetworkKeyManage, IMessage> {

        @Override
        public IMessage onMessage(NetworkKeyManage message,
                                  MessageContext ctx) {
            String[] split = message.toSend.split("~");
            String key = split[0];
            EntityPlayerMP player = ctx.getServerHandler().playerEntity;

            try {
                if (key.equals("useItem"))
                    InputUtils.useItemPressedPlayers.put(player.getUniqueID(), Boolean.parseBoolean(split[1]));
            } catch (Exception e) {
                System.out.println(e.getMessage());
            }

            return null;
        }
    }
}