package xamora.gp_dbc.network.server;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayerMP;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.network.client.NetworkCriminalTrackerC;
import xamora.gp_dbc.proxy.CommonProxy;
import xamora.gp_dbc.system.Criminal;
import xamora.gp_dbc.utils.InputUtils;

import static xamora.gp_dbc.config.ConfigManager.*;

public class NetworkRefreshCriminalTracker implements IMessage {

    private String toSend;

    public NetworkRefreshCriminalTracker() {}

    public NetworkRefreshCriminalTracker(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf,toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandler implements
            IMessageHandler<NetworkRefreshCriminalTracker, IMessage> {

        @Override
        public IMessage onMessage(NetworkRefreshCriminalTracker message,
                                  MessageContext ctx) {

            EntityPlayerMP player = ctx.getServerHandler().playerEntity;
            boolean isCops = Main.gp.isInGalacticPatrol(player);

            String criminals = "";
            for (Criminal criminal : Main.gp.criminals.criminals) {
                Main.gp.criminals.getUpdatePos(criminal.getUuid());
                if (isCops)
                    criminals += criminal.toString() + "#";
                else
                    criminals += criminal.toStringWithoutPos() + "#";
            }

            CommonProxy.network.sendTo(new NetworkCriminalTrackerC("open~" + criminals + "~" + MAX_RATE_CRIMINAL + "#" + RATE_TO_HAVE_POSITION + "#" + RATE_CRIMINAL_NOT_SAFE), player);

            return null;
        }
    }
}