package xamora.gp_dbc.render;

import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.system.Handcuff;
import xamora.gp_dbc.system.Handcuffed;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.multiplayer.WorldClient;
import net.minecraft.client.renderer.culling.Frustrum;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.Vec3;
import net.minecraftforge.client.event.RenderWorldLastEvent;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import org.lwjgl.opengl.GL11;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class RenderHandcuffIcon extends Gui {

    // UUID | start
    @SideOnly(Side.CLIENT)
    public static HashMap<UUID, Long> playerAroundHandcuffed = new HashMap<>();
    public static HashMap<UUID, Boolean> playerAroundUnhandcuffing = new HashMap<>();

    public static boolean renderInF1 = false;
    public static double heightAbove = 0.6D;

    public static List<EntityPlayer> listPlayers;
    Minecraft mc = Minecraft.getMinecraft();
    public String helmet;

    @SubscribeEvent
    public void onRenderWorldLast(RenderWorldLastEvent event) {

        if (!renderInF1 && !Minecraft.isGuiEnabled())
            return;

        EntityLivingBase cameraEntity = mc.renderViewEntity;
        Vec3 renderingVector = cameraEntity.getPosition(event.partialTicks);
        Frustrum frustrum = new Frustrum();
        double viewX = cameraEntity.lastTickPosX + (cameraEntity.posX - cameraEntity.lastTickPosX) * event.partialTicks;
        double viewY = cameraEntity.lastTickPosY + (cameraEntity.posY - cameraEntity.lastTickPosY) * event.partialTicks;
        double viewZ = cameraEntity.lastTickPosZ + (cameraEntity.posZ - cameraEntity.lastTickPosZ) * event.partialTicks;
        frustrum.setPosition(viewX, viewY, viewZ);
        WorldClient client = mc.theWorld;
        EntityPlayer mainPlayer = mc.thePlayer;

        listPlayers = Minecraft.getMinecraft().theWorld.playerEntities;
        //Set<Entity> entities = (Set<Entity>)ReflectionHelper.getPrivateValue(WorldClient.class, client, new String[] { "entityList", "field_73032_d", "J" });
        for (EntityPlayer player : listPlayers) {
            if (player != null
                    && player.isInRangeToRender3d(renderingVector.xCoord, renderingVector.yCoord, renderingVector.zCoord) && (player.ignoreFrustumCheck || frustrum.isBoundingBoxInFrustum(player.boundingBox))
                    && player.isEntityAlive()
                    && playerAroundHandcuffed.containsKey(player.getUniqueID())) {

                long time_left = (playerAroundHandcuffed.get(player.getUniqueID()) + (Handcuffed.timeToWait * 1000) - System.currentTimeMillis()) / 1000;
                if (time_left < -Handcuffed.timeToWait)
                    playerAroundHandcuffed.remove(player.getUniqueID());
                else
                    renderPseudo((EntityLivingBase) player, event.partialTicks, (Entity) cameraEntity, 13816530);
            }
        }
    }

    public void renderPseudo(EntityLivingBase passedEntity, float partialTicks, Entity viewPoint, int opacity) {
        if (passedEntity.riddenByEntity != null)
            return;

        EntityPlayer player = (EntityPlayer) passedEntity;
        Minecraft mc = Minecraft.getMinecraft();
        float pastTranslate = 0.0F;

        float distance = passedEntity.getDistanceToEntity(viewPoint);

        double x = passedEntity.lastTickPosX + (passedEntity.posX - passedEntity.lastTickPosX) * partialTicks;
        double y = passedEntity.lastTickPosY + (passedEntity.posY - passedEntity.lastTickPosY) * partialTicks;
        double z = passedEntity.lastTickPosZ + (passedEntity.posZ - passedEntity.lastTickPosZ) * partialTicks;
        float scale = 0.026666673F;

        GL11.glPushMatrix();
        GL11.glTranslatef((float) (x - RenderManager.renderPosX), (float) (y - RenderManager.renderPosY + passedEntity.height + heightAbove), (float) (z - RenderManager.renderPosZ));
        GL11.glNormal3f(0.0F, 1.0F, 0.0F);
        GL11.glRotatef(-RenderManager.instance.playerViewY, 0.0F, 1.0F, 0.0F);
        float viewX = RenderManager.instance.playerViewX;
        if (passedEntity == mc.thePlayer)
            viewX = Math.min(Math.max(RenderManager.instance.playerViewX, -5), 5);
        GL11.glRotatef(viewX, 1.0F, 0.0F, 0.0F);
        //System.out.println(RenderManager.instance.playerViewX);
        GL11.glScalef(-scale, -scale, scale);
        GL11.glDisable(2896);
        GL11.glDepthMask(false);
        GL11.glDisable(2929);
        GL11.glDisable(3553);
        GL11.glEnable(3042);
        GL11.glBlendFunc(770, 771);
        GL11.glTranslatef(0.0F, pastTranslate, 0.0F);

        float s = 0.60F;

        int pos_y = 0;
        if (passedEntity == mc.thePlayer)
            pos_y = 120;
        float size = 20;

        long time_left = (playerAroundHandcuffed.get(player.getUniqueID()) + (Handcuffed.timeToWait * 1000) - System.currentTimeMillis()) / 1000;

        GL11.glEnable(3553);
        GL11.glPushMatrix();
        GL11.glTranslatef(-size, 6.0F, 0.0F);
        GL11.glScalef(s, s, s);
        mc.fontRenderer.drawString(String.valueOf(time_left), 40, pos_y - 25, opacity, true); // String, x, y, color, shadow(true,false)

        mc.renderEngine.bindTexture(new ResourceLocation(Main.MODID, "textures/gui/handcuffed.png"));

        int guiWidth = 212 / 2 + 1;
        int guiHeight = 320 / 2 + 1;

        boolean unhandcuffing = playerAroundUnhandcuffing.get(player.getUniqueID());

        // Texture
        GL11.glPushMatrix();
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        //GL11.glColor4d(0.1, 0.6, 0.96, 0.95);
        //GL11.glTranslated(0,0, 1);
        if (!unhandcuffing) {
            GL11.glColor4d(0.9, 0.9, 0.9, 0.95);
            drawTexturedModalRect(0, pos_y - 30, 0, 0, 37, 18);
        }
        else {
            GL11.glColor4d(1, 1, 1, 0.95);
            drawTexturedModalRect(0, pos_y - 30, 38, 0, 37, 21);
        }
        GL11.glPopMatrix();


        GL11.glPushMatrix();
        float s1 = 0.75F;
        GL11.glScalef(s1, s1, s1);

        GL11.glPopMatrix();
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        int off = 0;
        s1 = 0.5F;
        GL11.glScalef(s1, s1, s1);
        GL11.glTranslatef(size / s * s1 * 2.0F - 16.0F, 0.0F, 0.0F);
        mc.renderEngine.bindTexture(TextureMap.locationItemsTexture);

        GL11.glPopMatrix();
        GL11.glEnable(2929);
        GL11.glDepthMask(true);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        GL11.glPopMatrix();

    }

    @SubscribeEvent
    public void onJoinWorldReset(EntityJoinWorldEvent entityJoinWorldEvent) {
        if (!entityJoinWorldEvent.entity.equals(Minecraft.getMinecraft().thePlayer))
            return;

        playerAroundHandcuffed.clear();
        playerAroundUnhandcuffing.clear();
    }
}
