package xamora.gp_dbc.system;

import xamora.gp_dbc.config.ConfigManager;

import java.util.List;
import java.util.UUID;

public class Handcuffed {

    public long start_time;
    boolean unhandcuffing;

    public UUID inmate;
    public UUID jailer;

    public static long timeToWait = ConfigManager.TIME_TO_GO_IN_JAIL;

    public Handcuffed(UUID inmate, UUID jailer) {
        this(inmate, jailer, System.currentTimeMillis(), false);
    }

    public Handcuffed(UUID inmate, long start_time) {
        this(inmate, null, start_time, false);
    }

    public Handcuffed(UUID inmate, long start_time, boolean unhandcuffing) {
        this(inmate, null, start_time, unhandcuffing);
    }

    public Handcuffed(UUID inmate, UUID jailer, long start_time, boolean unhandcuffing) {
        this.inmate = inmate;
        this.jailer = jailer;
        this.start_time = start_time;
        this.unhandcuffing = unhandcuffing;
    }

    public boolean equals(UUID inmate) {
        return this.inmate == inmate;
    }

    public boolean equals(UUID inmate, long start_time) {
        return this.inmate == inmate && this.start_time == start_time;
    }

    public boolean equals(UUID inmate, UUID jailer, long start_time) {
        return this.inmate == inmate && this.start_time == start_time && this.jailer == jailer;
    }

    public boolean equals(UUID inmate, UUID jailer, long start_time, boolean unhandcuffing) {
        return this.inmate == inmate && this.start_time == start_time && this.jailer == jailer && this.unhandcuffing == unhandcuffing;
    }

    public static boolean contains_handcuffed(List<Handcuffed> handcuffeds, UUID inmate) {
        return contains_handcuffed(handcuffeds, inmate, null, false);
    }

    public static boolean contains_handcuffed(List<Handcuffed> handcuffeds, UUID inmate, Long start_time, boolean unhandcuffing) {
        return contains_handcuffed(handcuffeds, inmate, null, start_time, unhandcuffing);
    }

    public static boolean contains_handcuffed(List<Handcuffed> handcuffeds, UUID inmate, UUID jailer, Long start_time, boolean unhandcuffing) {
        for (Handcuffed hdfd : handcuffeds) {
            if (start_time == null && jailer == null) {
                if (hdfd.equals(inmate))
                    return true;
            }
            else if (start_time == null) {
                if (hdfd.equals(inmate, start_time))
                    return true;
            }
            else
                if (hdfd.equals(inmate, jailer, start_time, unhandcuffing))
                    return true;
        }

        return false;
    }
}
