package xamora.gp_dbc.system;

import JinRyuu.JRMCore.server.JGPlayerMP;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.PlayerEvent;
import cpw.mods.fml.common.gameevent.TickEvent;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import fastcraft.J;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.living.LivingHurtEvent;
import xamora.gp_dbc.Main;
import xamora.gp_dbc.utils.PlayerUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import xamora.gp_dbc.utils.Pos;

import static net.minecraft.util.StatCollector.translateToLocal;
import static xamora.gp_dbc.Main.gp;

public class JailEvent {

    int tick_time = 0;
    final int SLOWTICK_MAX = 20;//2000;

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkTimeInmate(TickEvent.ServerTickEvent event) {
        if (tick_time >= SLOWTICK_MAX) {
            tick_time = 0;

            if (gp.jail.getInmates() == null)
                return;

            for (int i = 0; i < gp.jail.getInmates().size(); i++) {
                Inmate inmate = gp.jail.getInmates().get(i);

                if (System.currentTimeMillis() - inmate.getTimeStartJail() > inmate.getSecInJail() * 1000) {

                    // Connected
                    EntityPlayer player = PlayerUtils.getPlayerFromUUID(inmate.getUuid());
                    if (player == null)
                        gp.jail.removePlayerFromJail(MinecraftServer.getServer(), inmate.getUuid(), true);
                    else
                        gp.jail.removePlayerFromJail(MinecraftServer.getServer(), player, true);
                }
            }
        }
        else
            tick_time++;
    }

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkPlayerIsFree(PlayerEvent.PlayerLoggedInEvent event) {
        if (gp.jail.freePlayer(event.player))
            event.player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.out_of_jail")));

        Inmate inmate = gp.jail.getInmate(event.player.getUniqueID());
        if (inmate != null) {
            long time_left = (inmate.getSecInJail() * 1000 - (System.currentTimeMillis() - inmate.getTimeStartJail())) / 1000;
            String timeString = gp.jail.displayTimeInJail(time_left);

            if (!translateToLocal("msg.inmate_going_to_jail").isEmpty())
                event.player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("msg.inmate_going_to_jail") + timeString));

            JGPlayerMP jgPlayer = new JGPlayerMP(event.player);
            NBTTagCompound nbt = jgPlayer.connectBaseNBT();

            if (nbt.getByte("jrmcAlv") == 1)
                nbt.setByte("jrmcAlv", (byte) 0);

            inmate.getCell().tpTo(event.player);
        }

    }

    int tick_release = 0;

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkRelease(TickEvent.ServerTickEvent event) {
        if (tick_release >= SLOWTICK_MAX) {
            tick_release = 0;

            if (gp.jail.getInmates() == null)
                return;

            for (int i = 0; i < gp.jail.getInmates().size(); i++) {
                Inmate inmate = gp.jail.getInmates().get(i);

                EntityPlayer player = PlayerUtils.getPlayerFromUUID(inmate.getUuid());
                if (player != null) {
                    JGPlayerMP jgPlayer = new JGPlayerMP(player);
                    NBTTagCompound nbt = jgPlayer.connectBaseNBT();

                    if (jgPlayer.getRelease() > 0)
                        jgPlayer.setRelease(0);
                }
            }
        }
        else
            tick_release++;
    }

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkDeathCancel(LivingHurtEvent event) {
        if (!(event.entity instanceof EntityPlayer))
            return;

        EntityPlayer player = (EntityPlayer)event.entity;
        if (gp.jail.isInJail(player))
            event.setCanceled(true);
    }
}
